/***********************************************************************
 * Copyright (C) 2002,2003,2004,2005,2006,2007,2008 Carsten Urbach
 *
 * This file is part of tmLQCD.
 *
 * tmLQCD is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * tmLQCD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with tmLQCD.  If not, see <http://www.gnu.org/licenses/>.
 *
 * invert_eo makes an inversion with EO precoditioned
 * tm Operator
 *
 * Author: Carsten Urbach
 *         urbach@physik.fu-berlin.de
 *
 ***********************************************************************/

#ifndef _INVERT_EO_H
#define _INVERT_EO_H
#include "global.h"
#include "solver/solver_params.h"

int invert_eo(spinor * const Even_new, spinor * const Odd_new, 
              spinor * const Even, spinor * const Odd,
              const double precision, const int iter_max,
              const int solver_flag, const int rel_prec,
              const int sub_evs_flag, const int even_odd_flag,
              const int no_extra_masses, double * const extra_masses, solver_params_t solver_params, const int id,
              const ExternalInverter inverter, const SloppyPrecision sloppy, const CompressionType compression );

#endif
